//
//  ProfileWireframe.swift
//  SuperSpaManagement
//
//  Created by PHAM ANH TUAN on 3/8/21.
//  Copyright (c) 2021 ___ORGANIZATIONNAME___. All rights reserved.
//
//  This file was generated by the 🐍 VIPER generator
//

import UIKit

final class ProfileWireframe: BaseWireframe {

    // MARK: - Private properties -

    private let storyboard = UIStoryboard(name: "Profile", bundle: nil)

    // MARK: - Module setup -

    init(membership: Membership) {
        let moduleViewController = storyboard.instantiateViewController(ofType: ProfileViewController.self)
        super.init(viewController: moduleViewController)

        let interactor = ProfileInteractor()
        let presenter = ProfilePresenter(
            view: moduleViewController,
            interactor: interactor,
            wireframe: self,
            membership: membership
        )
        
        moduleViewController.presenter = presenter
    }

}

// MARK: - Extensions -

extension ProfileWireframe: ProfileWireframeInterface {
    func navigate(to option: ProfileNavigationOption) {
        switch option {
        case .profileSettings:
            let wireframe = ProfileSettingsWireframe()
            navigationController?.pushWireframe(wireframe)
            
        case let .editMembershipinfo(membership):
            let wireframe = MembershipEditingWireframe(style: .edit(membership: membership))
            navigationController?.pushWireframe(wireframe)
            
        case let .createTransaction(membership):
            let wireframe = TransactionsWireframe(style: .createNew(membership: membership))
            navigationController?.pushWireframe(wireframe)
        }
    }
}
